/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.1
 * Date               : 2020/08/06
 * Description        : ӻӦϵͳʼ
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

/******************************************************************************/
/* ͷļ */
#include "CONFIG.h"
#include "HAL.h"
#include "gattprofile.h"
#include "peripheral.h"
#include "app_usb.h"

/*********************************************************************
 * GLOBAL TYPEDEFS
 */
__attribute__((aligned(4))) uint32_t MEM_BUF[BLE_MEMHEAP_SIZE / 4];

#if(defined(BLE_MAC)) && (BLE_MAC == TRUE)
const uint8_t MacAddr[6] = {0x84, 0xC2, 0xE4, 0x03, 0x02, 0x02};
#endif

/*********************************************************************
 * @fn      Main_Circulation
 *
 * @brief   ѭ
 *
 * @return  none
 */
__HIGH_CODE
__attribute__((noinline))
void Main_Circulation()
{
    while(1)
    {
        TMOS_SystemProcess();
    }
}

tmosTaskID halTestID;
tmosEvents HAL_ProcessTestEvent(tmosTaskID task_id, tmosEvents events)
{
	if (events & HAL_REG_INIT_EVENT)
	{
		extern unsigned char _ebss[];
		extern unsigned char _eusrstack[];

		int zero_size = _eusrstack - _ebss;


        int last_0x00_start = 0;
        int last_0x00_end = 0;
        int last_0x00_max = 0;


		int now_0x00_start = 0;
		int now_0x00_end = 0;
		int now_0x00_max = 0;
        for (int i = 0; i< zero_size; i++)
        {
            unsigned char a = _ebss[i];
            if (a == 0x00)
            {
                now_0x00_max++;
                now_0x00_end = i;
                if (now_0x00_start == 0)
                {
                    now_0x00_start = i;
                }
            }
            else
            {
                if (now_0x00_max > last_0x00_max)
                {
                    last_0x00_max = now_0x00_max;
                    last_0x00_end = now_0x00_end;
                    last_0x00_start = now_0x00_start;
                }
                now_0x00_start = 0;
                now_0x00_end = 0;
                now_0x00_max = 0;
            }
        }


        PRINT("Heap[%2d%%] Stack[%2d%%] Free[%2d%%]\n", last_0x00_start * 100 / zero_size, (zero_size - last_0x00_end) * 100 / zero_size, last_0x00_max * 100 / zero_size);
        GPIOB_InverseBits(bPWM7);
		return events ^ HAL_REG_INIT_EVENT;
	}
	
	return 0;
}



/*********************************************************************
 * @fn      main
 *
 * @brief   
 *
 * @return  none
 */
int main(void)
{
#if(defined(DCDC_ENABLE)) && (DCDC_ENABLE == TRUE)
    PWR_DCDCCfg(ENABLE);
#endif
    SetSysClock(CLK_SOURCE_PLL_80MHz);
#if(defined(HAL_SLEEP)) && (HAL_SLEEP == TRUE)
    GPIOA_ModeCfg(GPIO_Pin_All, GPIO_ModeIN_PU);
    GPIOB_ModeCfg(GPIO_Pin_All, GPIO_ModeIN_PU);
#endif
#ifdef DEBUG
    GPIOA_SetBits(bTXD1);
    GPIOA_ModeCfg(bTXD1, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
#endif
    GPIOB_ModeCfg(bPWM7, GPIO_ModeOut_PP_5mA);

    PRINT("%s\n", VER_LIB);
    CH58X_BLEInit();
    HAL_Init();
    GAPRole_PeripheralInit();
    Peripheral_Init();
    app_usb_init();


    halTestID = TMOS_ProcessEventRegister(HAL_ProcessTestEvent);
	tmos_start_reload_task(halTestID, HAL_REG_INIT_EVENT, MS1_TO_SYSTEM_TIME(1000)); // У׼񣬵У׼ʱС10ms

    Main_Circulation();
}

/******************************** endfile @ main ******************************/
